Merge "[CPS] Fix SonarQube Violations / Improve Coverage - Recurring task"
[cps.git] / test-tools / test-deregistration.sh
1 #!/bin/bash
2 #
3 # Copyright 2023 Nordix Foundation.
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16 #
17
18 set -o errexit  # Exit on most errors
19 set -o nounset  # Disallow expansion of unset variables
20 set -o pipefail # Use last non-zero exit code in a pipeline
21 #set -o xtrace   # Uncomment for debugging
22
23 GRAB_METRICS=true
24 DOCKER_COMPOSE_FILE=../docker-compose/docker-compose.yml
25 CREATE_REQUEST=/tmp/cmhandles-create-req.txt
26 REMOVE_REQUEST=/tmp/cmhandles-remove-req.txt
27 REPORT_FILE=metrics-reports/deregister-summary-$(date --iso-8601=seconds).tsv
28
29 stop_docker() {
30     docker-compose -f $DOCKER_COMPOSE_FILE down >/dev/null
31     docker container prune -f >/dev/null
32     docker volume prune -f >/dev/null
33 }
34
35 restart_docker() {
36     stop_docker
37     docker-compose -f $DOCKER_COMPOSE_FILE --profile dmi-stub --profile monitoring up -d >/dev/null
38 }
39
40 wait_for_cps_to_start() {
41     docker logs cps-and-ncmp -f | grep -m 1 'Started Application' >/dev/null || true
42 }
43
44 get_number_of_handles_ready() {
45     PGPASSWORD=cps psql -h localhost -p 5432 cpsdb cps -c \
46         "SELECT count(*) FROM public.fragment where attributes @> '{\"cm-handle-state\": \"READY\"}';" \
47         | sed '3!d' | sed 's/ *//'
48 }
49
50 wait_for_handles_to_be_ready() {
51     local TOTAL_HANDLES=$1
52     while
53         sleep 30
54         HANDLES_READY=$(get_number_of_handles_ready)
55         echo "There are $HANDLES_READY CM handles in READY state."
56         [ $HANDLES_READY -ne $TOTAL_HANDLES ]
57     do true; done
58 }
59
60 create_handles() {
61     curl --fail --silent --show-error \
62         --location 'http://localhost:8883/ncmpInventory/v1/ch' \
63         --header 'Authorization: Basic Y3BzdXNlcjpjcHNyMGNrcyE=' \
64         --header 'Content-Type: application/json' \
65         --data @$CREATE_REQUEST
66 }
67
68 remove_handles_and_record_time() {
69     curl --fail --silent --show-error --output /dev/null --write-out '%{time_total}\n' \
70         --location 'http://localhost:8883/ncmpInventory/v1/ch' \
71         --header 'Authorization: Basic Y3BzdXNlcjpjcHNyMGNrcyE=' \
72         --header 'Content-Type: application/json' \
73         --data @$REMOVE_REQUEST >> $REPORT_FILE
74 }
75
76 create_request_bodies() {
77     local CREATE_SIZE=$1
78     local REMOVE_SIZE=$2
79     echo -n '{"dmiPlugin": "http://ncmp-dmi-plugin-stub:8080","createdCmHandles":[' > $CREATE_REQUEST
80     echo -n '{"dmiPlugin": "http://ncmp-dmi-plugin-stub:8080","removedCmHandles":[' > $REMOVE_REQUEST
81     for i in $(seq 1 $CREATE_SIZE); do
82         local CMHANDLE=$(uuidgen | tr -d '-')
83         echo -n "{\"cmHandle\": \"$CMHANDLE\",\"cmHandleProperties\":{\"neType\":\"RadioNode\"}}" \
84             >> $CREATE_REQUEST
85         if [ $i -lt $CREATE_SIZE ]; then
86             echo -n "," >> $CREATE_REQUEST
87         fi
88         if [ $i -le $REMOVE_SIZE ]; then
89             echo -n "\"$CMHANDLE\"" >> $REMOVE_REQUEST
90         fi
91         if [ $i -lt $REMOVE_SIZE ]; then
92             echo -n "," >> $REMOVE_REQUEST
93         fi
94     done
95     echo ']}' >> $CREATE_REQUEST
96     echo ']}' >> $REMOVE_REQUEST
97 }
98
99 test_deregistration() {
100     local REMOVE_SIZE=$1
101     local CREATE_SIZE=$2
102
103     echo "Testing deregistration of $REMOVE_SIZE out of $CREATE_SIZE CM handles"
104
105     echo "Restarting docker"
106     restart_docker
107     echo "Waiting for CPS to start"
108     wait_for_cps_to_start
109
110     echo "Creating request bodies"
111     create_request_bodies $CREATE_SIZE $REMOVE_SIZE
112
113     echo "[$(date --iso-8601=seconds)] Creating CM handles"
114     create_handles
115     echo "Waiting for CM handles to be in READY state"
116     wait_for_handles_to_be_ready $CREATE_SIZE
117
118     if [ "$GRAB_METRICS" = "true" ]; then
119         echo "Grabbing metrics before deregistration"
120         METRICS_BEFORE=$(./generate-metrics-report.sh)
121     fi
122
123     echo "[$(date --iso-8601=seconds)] Removing CM handles"
124     echo -e -n "$REMOVE_SIZE\t$CREATE_SIZE\t" >> $REPORT_FILE
125     remove_handles_and_record_time
126     echo "There are $(get_number_of_handles_ready) CM handles still in READY state."
127
128     if [ "$GRAB_METRICS" = "true" ]; then
129         echo "Grabbing metrics after deregistration"
130         METRICS_AFTER=$(./generate-metrics-report.sh)
131         echo "Generating metrics report"
132         ./subtract-metrics-reports.py -a $METRICS_AFTER -b $METRICS_BEFORE \
133             -o metrics-reports/deregister-$(date --iso-8601=seconds)-$REMOVE_SIZE-$CREATE_SIZE.tsv
134         rm $METRICS_BEFORE $METRICS_AFTER
135     fi
136
137     echo
138 }
139
140 cleanup() {
141     rm -f "$CREATE_REQUEST" "$REMOVE_REQUEST"
142     stop_docker
143     popd
144 }
145 trap cleanup EXIT
146
147 pushd -- "$(dirname -- "${BASH_SOURCE[0]}")"
148
149 mkdir -p $(dirname $REPORT_FILE)
150 echo -e "Removed\tTotal\tTime" > $REPORT_FILE
151
152 for number_to_delete in 100 500 1000 5000 10000 20000; do
153     test_deregistration $number_to_delete $number_to_delete
154 done
155